Subject: bug#59929: closed (Re: [PATCH]: Eglot, request progress notification on server init)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 25 Mar 2023 19:14:02 +0000

Your bug report

#59929: [PATCH]: Eglot, request progress notification on server init

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
59929: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=59929
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: [PATCH]: Eglot, request progress notification on server init
From: João Távora <[email-masked]>
To: Danny Freeman <[email-masked]>, [email-masked]
Date: Sat, 25 Mar 2023 19:15:29 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

On Sat, Mar 25, 2023 at 7:12 PM Danny Freeman <[email-masked]> wrote:
>
>
> Danny Freeman <[email-masked]> writes:
>
> > Another patch for consideration related to the first in this thread,
> > I've confirmed that clients can signal to servers that they are willing
> > to accept server initiated progress notifications with the client
> > capability in the attached patch.
> >
> > Note: there is still no server capability for this that can be ignored,
> > and the `eglot-report-progress` defcustom remains relevant here. Any
> > server initiated progress report will be ignored if
> > `eglot-report-progress` is `nil`.
> >
> > Server will send a `window/workDoneProgress/create` request, but nothing
> > needs to be done with it. That request will be followed by the already
> > implemented $/progress notifications.
> >
> > I need to find a server that I can test this with before this patch is
> > applied. I will report back in this thread once I've done that.
>
> I think this bug can be closed. It is old and I lost track of it, but
> some recent commits in Emacs I think addressed this
>
> - 82523dc621ace104d8f379509a436fcb03c48c26
> - 47d8e4b0d3835f5e0b0b6ab76f242ef0aa25bda7
>
> Thank you,
> Danny Freeman

Yes, I think so to.  I had lost track of this bug,
thanks for reminding me.

João

Subject: [PATCH]: Eglot, request progress notification on server init
From: Danny Freeman <[email-masked]>
To: [email-masked]
Date: Fri, 09 Dec 2022 14:55:05 -0500
List-Id: <debbugs-submit.debbugs.gnu.org>

I would like to propose a change to Eglot that builds on my last patch
in bug 59149.

What I did not realize at the time of writing that patch, is that
clients can opt into receiving progress notifications for server
initialization when sending the `:initialize` request.
This is useful for slow starting servers or large projects that require
the lsp server to do a lot of analysis on startup. The server of course
has to be able to send these progress reports. Not all of them do and
may ignore this parameter.

If users do not want to see this, they can set `eglot-report-progress`
to `nil`.

There are other requests that extend the WorkDoneProgressParams
interface that this could also be done for. It may be worth looking
through the spec and seeing if it makes sense to send this param with
other requests. Many of them are for typically quick requests like
`textDocument/definition`

Thank you,
-- 
Danny Freeman

>From 1b81fa34ff282bfca0f754afad2c9eca04ad7985 Mon Sep 17 00:00:00 2001
From: dannyfreeman <[email-masked]>
Date: Fri, 9 Dec 2022 14:40:01 -0500
Subject: [PATCH] Eglot: show progress reports for slow starting servers

* lisp/progmodes/eglot.el (eglot--connect): report progress on
initialization

This takes advantage of the new `eglot-handle-notification`
implementation of the LSP $/progress method.

Slow starting servers will now show their progress in the
minibuffer if `eglot-report-progress` is `t`. The server must
also opt in to providing the $/progress notifications.

See
https://microsoft.github.io/language-server-protocol/specifications/lsp/3.17/specification/#initialize
for more information on the InitializeParams interface.
---
 lisp/progmodes/eglot.el | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

diff --git a/lisp/progmodes/eglot.el b/lisp/progmodes/eglot.el
index a53f62fc565..cceb9fb5b32 100644
--- a/lisp/progmodes/eglot.el
+++ b/lisp/progmodes/eglot.el
@@ -1291,7 +1291,10 @@ eglot--connect
                             :initializationOptions (eglot-initialization-options
                                                     server)
                             :capabilities (eglot-client-capabilities server)
-                            :workspaceFolders (eglot-workspace-folders server))
+                            :workspaceFolders (eglot-workspace-folders server)
+                            ;; Request $/progress notifications from the
+                            ;; server on startup.
+                            :workDoneToken "initialize")
                       :success-fn
                       (eglot--lambda ((InitializeResult) capabilities serverInfo)
                         (unless canceled
-- 
2.38.1